diff --git a/src/gui/MainWidget.cpp b/src/gui/MainWidget.cpp
index 22e46721..c900b8f2 100644
--- a/src/gui/MainWidget.cpp
+++ b/src/gui/MainWidget.cpp
@@ -1700,13 +1691,9 @@ void MainWidget::setStreamsMenu(const QStringList &videoStreams, const QStringLi
 
             if (hasData)
             {
-                connect(action, &QAction::triggered,
-                        this, [this, data = std::move(lines[1])] {
-                    if (data.startsWith("seek"))
-                        seek(QStringView(data).mid(4).toDouble());
-                    else
-                        playC.chStream(data);
-                });
+                // Qt4: Store data in action property, use helper slot
+                action->setProperty("streamData", lines[1]);
+                connect(action, SIGNAL(triggered()), this, SLOT(handleStreamActionTriggered()));
             }
             else
             {
@@ -1754,7 +1741,7 @@ QMenu *MainWidget::createPopupMenu()
     QMenu *popupMenu = QMainWindow::createPopupMenu();
     if (!fullScreen && !isCompactView)
     {
-#if !defined Q_OS_MACOS && !defined Q_OS_ANDROID
+#if !defined Q_OS_MAC && !defined Q_OS_ANDROID
         popupMenu->insertAction(popupMenu->actions().value(0), hideMenuAct);
         popupMenu->insertSeparator(popupMenu->actions().value(1));
         popupMenu->addSeparator();
@@ -1848,6 +1835,8 @@ bool MainWidget::getFullScreen() const
 
 void MainWidget::addChooseNextStreamKeyShortcuts()
 {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+    // Qt5+: Generic lambda (unused, kept for reference)
     auto chooseNextStream = [](const auto &actions) {
         if (actions.empty())
             return;
@@ -1867,20 +1856,18 @@ void MainWidget::addChooseNextStreamKeyShortcuts()
         }
         actions[0]->trigger();
     };
+    Q_UNUSED(chooseNextStream);
+#endif
 
     auto nextAudioStream = new QAction(tr("Next audio stream"), this);
-    connect(nextAudioStream, &QAction::triggered,
-            this, [=] {
-        chooseNextStream(menuBar->playback->audioStreams->actions());
-    });
+    // Qt4: Use helper slot
+    connect(nextAudioStream, SIGNAL(triggered()), this, SLOT(handleNextAudioStreamTriggered()));
     addAction(nextAudioStream);
     QMPlay2GUI.shortcutHandler->appendAction(nextAudioStream, "KeyBindings/NextAudioStream", "Ctrl+1");
 
     auto nextSubsStream = new QAction(tr("Next subtitles stream"), this);
-    connect(nextSubsStream, &QAction::triggered,
-            this, [=] {
-        chooseNextStream(menuBar->playback->subtitlesStreams->actions());
-    });
+    // Qt4: Use helper slot
+    connect(nextSubsStream, SIGNAL(triggered()), this, SLOT(handleNextSubsStreamTriggered()));
     addAction(nextSubsStream);
     QMPlay2GUI.shortcutHandler->appendAction(nextSubsStream, "KeyBindings/NextSubsStream", "Ctrl+2");
 }
@@ -1895,14 +1882,27 @@ inline const QList<DockWidget *> MainWidget::getDockWidgets() const
 #if QT_VERSION >= QT_VERSION_CHECK(6, 3, 0)
     return findChildren<DockWidget *>(Qt::FindDirectChildrenOnly);
 #else
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     return findChildren<DockWidget *>(QString(), Qt::FindDirectChildrenOnly);
+#else
+    // Qt4: Manually filter to get only direct children
+    QList<DockWidget *> result;
+    foreach (QObject *child, children())
+    {
+        if (DockWidget *dock = qobject_cast<DockWidget *>(child))
+            result.append(dock);
+    }
+    return result;
+#endif
 #endif
 }
 
 inline QRect MainWidget::winGeo() const
 {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     if (const auto win = windowHandle())
         return win->geometry();
+#endif
     return geometry();
 }
 
@@ -1935,7 +1935,7 @@ void MainWidget::storeDockSizes()
     }
 }
 
-#if defined(Q_OS_WIN)
+#if defined(Q_OS_WIN) && QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
 void MainWidget::setWindowsTaskBarFeatures()
 {
     if (QOperatingSystemVersion::current() < QOperatingSystemVersion::Windows7)
@@ -2000,7 +2000,7 @@ void MainWidget::setWindowsTaskBarFeatures()
     m_thumbnailToolBar->addButton(toggleMute);
     m_thumbnailToolBar->addButton(settings);
 }
-#endif
+#endif // Q_OS_WIN && QT_VERSION >= 5.0.0
 #if defined(Q_OS_WIN) && QT_VERSION < QT_VERSION_CHECK(6, 4, 0)
 void MainWidget::setTitleBarStyle()
 {
@@ -2047,6 +2047,7 @@ void MainWidget::mouseMoveEvent(QMouseEvent *e)
         bool canDisplayPanel = fullScreen || isCompactView;
         if (canDisplayPanel && !isToolbarVisible && fullScreen)
         {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
             const auto winScreen = windowHandle()->screen();
             const auto winScreenGeo = winScreen->geometry();
             const auto screens = QGuiApplication::screens();
@@ -2070,6 +2071,33 @@ void MainWidget::mouseMoveEvent(QMouseEvent *e)
                     break;
                 }
             }
+#else
+            // Qt4: Use QDesktopWidget
+            const QRect winScreenGeo = QApplication::desktop()->screenGeometry(this);
+            {
+                const int screenCount = QApplication::desktop()->screenCount();
+                for (int i = 0; i < screenCount; ++i)
+                {
+                    QRect geo = QApplication::desktop()->screenGeometry(i);
+                    if (geo == winScreenGeo)
+                        continue;
+
+                    if (m_fullscreenPanelsRightSide
+                        ? (geo.x() <= winScreenGeo.x())
+                        : (geo.x() >= winScreenGeo.x()))
+                    {
+                        continue;
+                    }
+
+                    geo.moveLeft(winScreenGeo.x());
+                    if (winScreenGeo.intersects(geo))
+                    {
+                        canDisplayPanel = false;
+                        break;
+                    }
+                }
+            }
+#endif
         }
 
         const int trigger1 = canDisplayPanel
@@ -2135,7 +2163,7 @@ void MainWidget::mouseMoveEvent(QMouseEvent *e)
                 playlistDock->show();
                 infoDock->show();
 
-                for (QMPlay2Extensions *QMPlay2Ext : std::as_const(visibleQMPlay2Extensions))
+                for (QMPlay2Extensions *QMPlay2Ext : visibleQMPlay2Extensions)
                     if (!QMPlay2Ext->isVisualization())
                         if (DockWidget *dw = QMPlay2Ext->getDockWidget())
                         {
@@ -2206,7 +2234,7 @@ void MainWidget::closeEvent(QCloseEvent *e)
     settings.set("MainWidget/FullScreenDockWidgetState", fullScreenDockWidgetState);
     settings.set("MainWidget/CompactViewDockWidgetState", m_compactViewDockWidgetState);
     settings.set("MainWidget/AlwaysOnTop", !!(windowFlags() & Qt::WindowStaysOnTopHint));
-#ifndef Q_OS_MACOS
+#ifndef Q_OS_MAC
     settings.set("MainWidget/isVisible", isVisible());
 #endif
     settings.set("MainWidget/IsCompactView", fullScreen ? m_compactViewBeforeFullScreen : isCompactView);
@@ -2353,8 +2381,12 @@ void MainWidget::resizeEvent(QResizeEvent *e)
             sizesH.push_back(qRound(size.height() * hRatio));
         }
 
+#if QT_VERSION >= QT_VERSION_CHECK(5, 6, 0)
         resizeDocks(docks, sizesH, Qt::Vertical);
         resizeDocks(docks, sizesW, Qt::Horizontal);
+#else
+        // Qt4: resizeDocks doesn't exist, skip this optimization
+#endif
     }
 }
 
@@ -2363,16 +2395,25 @@ bool MainWidget::eventFilter(QObject *obj, QEvent *event)
     if (tray && obj == tray && event->type() == QEvent::Wheel)
     {
         QWheelEvent *we = static_cast<QWheelEvent *>(event);
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
         volW->changeVolume(we->angleDelta().y() / 30);
+#else
+        // Qt4: Use delta() which returns an int
+        volW->changeVolume(we->delta() / 30);
+#endif
     }
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
     else if (event->type() == QEvent::FileOpen)
     {
         filesToAdd.append(((QFileOpenEvent *)event)->file());
         fileOpenTimer.start(10);
     }
 #endif
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     else if (event->type() == QEvent::Resize && m_keepDocksSize && obj == windowHandle())
+#else
+    else if (event->type() == QEvent::Resize && m_keepDocksSize && obj == this)
+#endif
     {
         for (auto &&dock : getDockWidgets())
         {
@@ -2382,7 +2423,265 @@ bool MainWidget::eventFilter(QObject *obj, QEvent *event)
     return QMainWindow::eventFilter(obj, event);
 }
 
-#ifdef Q_OS_MACOS
+// Qt4: Helper slot implementations for lambda conversions
+void MainWidget::handleShouldStoreSizes()
+{
+    m_storeDockSizesTimer.start();
+}
+
+void MainWidget::handleAddAndPlayRestoreWindow()
+{
+    m_restoreWindowOnVideo = true;
+}
+
+void MainWidget::handleClearInfo()
+{
+    infoDock->clear();
+    setStreamsMenu({}, {}, {}, {}, {});
+}
+
+void MainWidget::handleVideoNotStarted()
+{
+    m_restoreWindowOnVideo = false;
+}
+
+void MainWidget::handleSetVideoCheckState(bool rotate90, bool hFlip, bool vFlip, bool spherical)
+{
+    menuBar->playback->videoFilters->rotate90->setChecked(rotate90);
+    menuBar->playback->videoFilters->hFlip->setChecked(hFlip);
+    menuBar->playback->videoFilters->vFlip->setChecked(vFlip);
+    menuBar->playback->videoFilters->spherical->setChecked(spherical);
+}
+
+void MainWidget::handleContinuePos(double pos, bool canSetVar)
+{
+    const bool enabled = (pos > 0.0);
+    menuBar->player->continuePlayback->setProperty("Pos", pos);
+    menuBar->player->continuePlayback->setEnabled(enabled);
+    if (canSetVar)
+        playC.setDontResetContinuePlayback(enabled);
+}
+
+void MainWidget::handleAllowRecording(bool allow)
+{
+    menuBar->player->rec->setEnabled(allow);
+}
+
+void MainWidget::handleRecording(bool status)
+{
+#if QT_VERSION >= QT_VERSION_CHECK(5, 3, 0)
+    QSignalBlocker blocker(menuBar->player->rec);
+#else
+    const bool blocked = menuBar->player->rec->blockSignals(true);
+#endif
+    menuBar->player->rec->setChecked(status);
+#if QT_VERSION < QT_VERSION_CHECK(5, 3, 0)
+    menuBar->player->rec->blockSignals(blocked);
+#endif
+}
+
+void MainWidget::handleHideDocksTimeout()
+{
+    if (fullScreen || isCompactView)
+    {
+        if (playlistDock->isVisible())
+            hideDocks();
+        else
+            showToolBar(false);
+    }
+}
+
+// Qt4 helper slots - MOC needs to see declarations unconditionally
+void MainWidget::handleMaybeGoFullScreen()
+{
+#if defined(Q_OS_MAC) && QT_VERSION < QT_VERSION_CHECK(5, 4, 0)
+    if (m_maybeGoFullScreenCallback)
+        m_maybeGoFullScreenCallback();
+#endif
+}
+
+void MainWidget::handleRestoreState1()
+{
+#if QT_VERSION < QT_VERSION_CHECK(5, 4, 0)
+    QTimer::singleShot(0, this, SLOT(handleRestoreState2()));
+#endif
+}
+
+void MainWidget::handleRestoreState2()
+{
+#if QT_VERSION < QT_VERSION_CHECK(5, 4, 0)
+    QTimer::singleShot(0, this, SLOT(handleRestoreState3()));
+#endif
+}
+
+void MainWidget::handleRestoreState3()
+{
+#if QT_VERSION < QT_VERSION_CHECK(5, 4, 0)
+    restoreState(m_restoreStateData);
+    if (m_restoreStateToggleCompactView)
+        menuBar->window->toggleCompactView->trigger();
+    setUpdatesEnabled(true);
+    repaint();
+#endif
+}
+
+void MainWidget::handleDelEntries()
+{
+    playlistDock->delEntries(false);
+}
+
+void MainWidget::handleDelEntriesFromDisk()
+{
+    playlistDock->delEntries(true);
+}
+
+void MainWidget::handlePaste()
+{
+    playlistDock->paste(false);
+}
+
+void MainWidget::handlePasteAndPlay()
+{
+    playlistDock->paste(true);
+}
+
+void MainWidget::handleContinuePlayback()
+{
+    const double pos = menuBar->player->continuePlayback->property("Pos").toDouble();
+    if (pos > 0.0)
+        playC.seek(pos);
+    else
+    {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+        emit playC.continuePos(0.0, true);
+#else
+        // Qt4: signals are protected, use QMetaObject::invokeMethod
+        QMetaObject::invokeMethod(&playC, "continuePos", Qt::DirectConnection, Q_ARG(double, 0.0), Q_ARG(bool, true));
+#endif
+    }
+}
+
+void MainWidget::handleNewInstance()
+{
+    QProcess::startDetached(QCoreApplication::applicationFilePath(), QStringList() << "-noplay", QCoreApplication::applicationDirPath());
+}
+
+void MainWidget::handleSettingsChanged(int page, bool forceRestart, bool initFilters)
+{
+    Q_UNUSED(forceRestart);
+    Q_UNUSED(initFilters);
+    if (page == 2)
+        setContinuePlaybackVisibility();
+}
+
+void MainWidget::handleKeepDocksSizeChanged(bool keepDocksSize)
+{
+    m_keepDocksSize = keepDocksSize;
+    m_storeDockSizesTimer.start();
+}
+
+void MainWidget::handleFullscreenPanelsRightSideChanged(bool checked)
+{
+    m_fullscreenPanelsRightSide = checked;
+    fullScreenDockWidgetState.clear();
+    m_compactViewDockWidgetState.clear();
+}
+
+void MainWidget::handleHideOnCloseTriggered(bool checked)
+{
+    QMPlay2Core.getSettings().set("MainWidget/HideOnClose", checked);
+}
+
+void MainWidget::handleSecondMenuAboutToShow()
+{
+    QMenu *secondMenu = qobject_cast<QMenu *>(sender());
+    if (!secondMenu)
+        return;
+    for (auto ext : QMPlay2Extensions::QMPlay2ExtensionsList())
+    {
+        if (auto menu = ext->getTrayMenu())
+        {
+            ext->ensureTrayMenu();
+            if (!secondMenu->actions().contains(menu->menuAction()))
+                secondMenu->addMenu(menu);
+        }
+    }
+}
+
+void MainWidget::handleStreamActionTriggered()
+{
+    QAction *action = qobject_cast<QAction *>(sender());
+    if (!action)
+        return;
+    QString data = action->property("streamData").toString();
+    if (data.startsWith("seek"))
+    {
+        // Qt4: Use mid() instead of QStringView
+        seek(data.mid(4).toDouble());
+    }
+    else
+    {
+        playC.chStream(data);
+    }
+}
+
+void MainWidget::handleNextAudioStreamTriggered()
+{
+    auto actions = menuBar->playback->audioStreams->actions();
+    if (actions.empty())
+        return;
+
+    bool foundChecked = false;
+    foreach (QAction *action, actions)
+    {
+        if (action->isChecked())
+        {
+            foundChecked = true;
+        }
+        else if (foundChecked)
+        {
+            action->trigger();
+            return;
+        }
+    }
+    actions[0]->trigger();
+}
+
+void MainWidget::handleNextSubsStreamTriggered()
+{
+    auto actions = menuBar->playback->subtitlesStreams->actions();
+    if (actions.empty())
+        return;
+
+    bool foundChecked = false;
+    foreach (QAction *action, actions)
+    {
+        if (action->isChecked())
+        {
+            foundChecked = true;
+        }
+        else if (foundChecked)
+        {
+            action->trigger();
+            return;
+        }
+    }
+    actions[0]->trigger();
+}
+
+#ifdef Q_OS_WIN
+void MainWidget::handleThumbnailButtonChanged()
+{
+    // Windows-specific implementation - not needed for macOS target
+}
+
+void MainWidget::handleToggleMuteChanged()
+{
+    // Windows-specific implementation - not needed for macOS target
+}
+#endif
+
+#ifdef Q_OS_MAC
 void MainWidget::fileOpenTimerTimeout()
 {
     if (filesToAdd.count() == 1)
diff --git a/src/gui/MenuBar.cpp b/src/gui/MenuBar.cpp
index 3c5a8b7b..c34e6425 100644
--- a/src/gui/MenuBar.cpp
+++ b/src/gui/MenuBar.cpp
@@ -26,14 +26,14 @@
 #include <Settings.hpp>
 #include <Main.hpp>
 
-#include <QGuiApplication>
+#include <QApplication>
 #include <QWidgetAction>
 #include <QActionGroup>
 #include <QInputDialog>
 #include <QMainWindow>
 #include <qevent.h>
 #include <QDir>
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
     #include <QTimer>
 #endif
 
@@ -91,12 +91,17 @@ MenuBar::MenuBar()
     addMenu(options = new Options(this));
     addMenu(help = new Help(this));
     connect(widgets, SIGNAL(aboutToShow()), this, SLOT(widgetsMenuShow()));
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
     widgets->addAction(QString()); //Mac must have got at least one item inside menu, otherwise the menu is not shown
 #endif
 
     QMPlay2Core.registerProcessWheelEventFn([this](QWheelEvent *e) {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
         const auto deltaY  = e->angleDelta().y();
+#else
+        // Qt4: Use delta() which returns an int
+        const int deltaY = e->delta();
+#endif
         auto &settings = QMPlay2Core.getSettings();
         if (deltaY != 0 && e->buttons() == Qt::NoButton && settings.getBool("WheelAction"))
         {
@@ -120,7 +125,9 @@ MenuBar::Window::Window(MenuBar *parent) :
     newAction(Window::tr("&Compact view"), this, toggleCompactView, false, QIcon(), true);
     addSeparator();
 #ifndef Q_OS_ANDROID
-    if (!QGuiApplication::platformName().contains(QStringLiteral("wayland")))
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+    if (!QApplication::platformName().contains(QString("wayland")))
+#endif
         newAction(Window::tr("&Always on top"), this, alwaysOnTop, false, QIcon(), true);
     newAction(Window::tr("&Hide on close"), this, hideOnClose, false, QIcon(), true);
 #endif
@@ -342,13 +349,13 @@ MenuBar::Player::AspectRatio::AspectRatio(QMenu *parent) :
     _3x2->setObjectName(QString::number(3.0 / 2.0));
     _21x9->setObjectName(QString::number(21.0 / 9.0));
     sizeDep->setObjectName("sizeDep");
-    custom->setObjectName(QStringLiteral("custom:%1").arg(QMPlay2Core.getSettings().getDouble("CustomAspectRatio", 1.0)));
+    custom->setObjectName(QString("custom:%1").arg(QMPlay2Core.getSettings().getDouble("CustomAspectRatio", 1.0)));
     off->setObjectName("off");
 }
 
 void MenuBar::Player::seekActionsEnable(bool e)
 {
-#ifndef Q_OS_MACOS
+#ifndef Q_OS_MAC
     Qt::ShortcutContext ctx = e ? Qt::WindowShortcut : Qt::WidgetShortcut;
     seekF->setShortcutContext(ctx);
     seekB->setShortcutContext(ctx);
@@ -363,7 +370,7 @@ void MenuBar::Player::seekActionsEnable(bool e)
 }
 void MenuBar::Player::playActionEnable(bool e)
 {
-#ifndef Q_OS_MACOS
+#ifndef Q_OS_MAC
     togglePlay->setShortcutContext(e ? Qt::WindowShortcut : Qt::WidgetShortcut);
 #else
     togglePlay->setEnabled(e);
@@ -454,7 +461,7 @@ MenuBar::Playback::VideoFilters::VideoFilters(QMenu *parent) :
     QMenu(VideoFilters::tr("Video &filters"), parent)
 {
     /** Korektor wideo */
-#ifndef Q_OS_MACOS
+#ifndef Q_OS_MAC
     videoAdjustmentMenu = new QMenu(VideoFilters::tr("Video &adjustment"), this);
     addMenu(videoAdjustmentMenu);
     QWidgetAction *widgetAction = new QWidgetAction(this);
@@ -575,7 +582,7 @@ void MenuBar::setKeyShortcuts()
     shortcuts->appendAction(window->toggleFullScreen, "KeyBindings/Window-toggleFullScreen", "F");
     shortcuts->appendAction(window->toggleCompactView, "KeyBindings/Window-toggleCompactView", "Alt+V");
     shortcuts->appendAction(window->close, "KeyBindings/Window-close", "Ctrl+Q");
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
     window->toggleVisibility->setShortcuts({window->toggleVisibility->shortcut(), QKeySequence("Ctrl+W")});
 #endif
 
diff --git a/src/gui/OSDSettingsW.cpp b/src/gui/OSDSettingsW.cpp
index 2ad9bf29..e1a50f3a 100644
--- a/src/gui/OSDSettingsW.cpp
+++ b/src/gui/OSDSettingsW.cpp
@@ -32,7 +32,7 @@
 #include <QSpacerItem>
 #include <QLabel>
 #include <QSpinBox>
-#include <QGuiApplication>
+#include <QApplication>
 #include <QRadioButton>
 #include <QCoreApplication>
 
@@ -41,7 +41,8 @@
 void OSDSettingsW::init(const QString &prefix, int a, int b, int c, int d, int e, int f, double g, double h, const QColor &i, const QColor &j, const QColor &k, bool l, bool m)
 {
     Settings &QMPSettings = QMPlay2Core.getSettings();
-    QMPSettings.init(prefix + "/FontName", QGuiApplication::font().family());
+    // Qt4: Use QApplication instead of QGuiApplication
+    QMPSettings.init(prefix + "/FontName", QApplication::font().family());
     QMPSettings.init(prefix + "/FontSize", a);
     QMPSettings.init(prefix + "/Spacing", b);
     QMPSettings.init(prefix + "/Bold", l);
@@ -191,12 +192,7 @@ void OSDSettingsW::setupUi(QWidget *OSDSettings)
         alignL->addWidget(alignB[align], align / 3, align % 3);
     }
 
-    connect(m_backgroundCB, &QCheckBox::toggled, this, [this, shadowText = m_shadowColorL->text()](bool checked) {
-        m_shadowL->setEnabled(!checked);
-        m_shadowB->setEnabled(!checked);
-        m_shadowColorL->setText(checked ? tr("Background") : shadowText);
-        setShadowColorB();
-    });
+    connect(m_backgroundCB, SIGNAL(toggled(bool)), this, SLOT(handleBackgroundToggled(bool)));
 
     fontGB->setTitle(tr("Font"));
     fontSizeL->setText(tr("Size: "));
@@ -215,6 +211,9 @@ void OSDSettingsW::setupUi(QWidget *OSDSettings)
     textColorL->setText(tr("Text: "));
     outlineColorL->setText(tr("Border: "));
     m_shadowColorL->setText(tr("Shadow: "));
+
+    // Qt4: Store the default shadow color label text for the helper slot
+    m_shadowText = m_shadowColorL->text();
 }
 
 void OSDSettingsW::addWidget(QWidget *w)
@@ -272,3 +271,12 @@ inline void OSDSettingsW::setShadowColorB()
 {
     m_shadowColorB->setColor(QMPlay2Core.getSettings().getColor(prefix + (m_backgroundCB->isChecked() ? "/BackgroundColor" : "/ShadowColor")));
 }
+
+// Qt4: Helper slot implementation
+void OSDSettingsW::handleBackgroundToggled(bool checked)
+{
+    m_shadowL->setEnabled(!checked);
+    m_shadowB->setEnabled(!checked);
+    m_shadowColorL->setText(checked ? tr("Background") : m_shadowText);
+    setShadowColorB();
+}
diff --git a/src/gui/OSDSettingsW.hpp b/src/gui/OSDSettingsW.hpp
index e6ec647f..ee6067b8 100644
--- a/src/gui/OSDSettingsW.hpp
+++ b/src/gui/OSDSettingsW.hpp
@@ -50,6 +50,10 @@ private:
 
     inline void setShadowColorB();
 
+private slots:
+    // Qt4: Helper slot for lambda conversion
+    void handleBackgroundToggled(bool checked);
+
 private:
     QVBoxLayout *m_layout;
     QFontComboBox *m_fontCB;
@@ -70,4 +74,5 @@ private:
 
     QRadioButton *alignB[9];
     QString prefix;
+    QString m_shadowText;
 };
diff --git a/src/gui/PanGestureEventFilter.cpp b/src/gui/PanGestureEventFilter.cpp
index 45f3b479..da31d0b7 100644
--- a/src/gui/PanGestureEventFilter.cpp
+++ b/src/gui/PanGestureEventFilter.cpp
@@ -19,6 +19,7 @@
 #include <PanGestureEventFilter.hpp>
 #include <Functions.hpp>
 
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
 #include <QAbstractItemView>
 #include <QCoreApplication>
 #include <QScrollBar>
@@ -81,11 +82,13 @@ class PanGestureEventFilterPriv : public QObject
     const QScroller::ScrollerGestureType m_gestureType = QScroller::TouchGesture;
 #endif
 };
+#endif // QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
 
 /**/
 
 void PanGestureEventFilter::install()
 {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     static bool installed;
 
 #ifndef Q_OS_ANDROID
@@ -113,4 +116,7 @@ void PanGestureEventFilter::install()
     qApp->installEventFilter(new PanGestureEventFilterPriv);
 
     installed = true;
+#else
+    // Qt4: QScroller doesn't exist, no-op
+#endif
 }
diff --git a/src/gui/PlayClass.cpp b/src/gui/PlayClass.cpp
index 465e588b..6e63c192 100644
--- a/src/gui/PlayClass.cpp
+++ b/src/gui/PlayClass.cpp
@@ -34,7 +34,7 @@
 #include <Decoder.hpp>
 #include <Reader.hpp>
 
-#include <QGuiApplication>
+#include <QApplication>
 #include <QVarLengthArray>
 #include <QMessageBox>
 #include <QRawFont>
@@ -90,9 +90,9 @@ PlayClass::PlayClass() :
 
 
     connect(&timTerminate, SIGNAL(timeout()), this, SLOT(timTerminateFinished()));
-    connect(this, &PlayClass::aRatioUpdate, this, &PlayClass::aRatioUpdated);
+    connect(this, SIGNAL(aRatioUpdate(const AVRational &)), this, SLOT(aRatioUpdated(const AVRational &)));
     connect(this, SIGNAL(frameSizeUpdate(int, int)), this, SLOT(frameSizeUpdated(int, int)));
-    connect(this, &PlayClass::pixelFormatUpdate, this, &PlayClass::pixelFormatUpdated);
+    connect(this, SIGNAL(pixelFormatUpdate(int)), this, SLOT(pixelFormatUpdated(int)));
     connect(this, SIGNAL(audioParamsUpdate(quint8, quint32)), this, SLOT(audioParamsUpdated(quint8, quint32)));
 }
 PlayClass::~PlayClass()
@@ -122,16 +122,8 @@ void PlayClass::play(const QString &_url)
             demuxThr->updateBufferedSeconds = QMPlay2Core.getSettings().getBool("ShowBufferedTimeOnSlider");
 
             connect(demuxThr, SIGNAL(load(Demuxer *)), this, SLOT(load(Demuxer *)));
-            connect(demuxThr, &DemuxerThr::allowRecording, this, &PlayClass::allowRecording);
-            connect(demuxThr, &DemuxerThr::recording, this, [this](bool status, bool error, const QString &fileName) {
-                if (error)
-                    messageAndOSD(tr("Recording error"));
-                else if (status)
-                    messageAndOSD(tr("Recording started: %1").arg(fileName));
-                else
-                    messageAndOSD(tr("Recording stopped"));
-                emit recording(status && !error);
-            });
+            connect(demuxThr, SIGNAL(allowRecording(bool)), this, SIGNAL(allowRecording(bool)));
+            connect(demuxThr, SIGNAL(recording(bool, bool, const QString &)), this, SLOT(handleDemuxerRecording(bool, bool, const QString &)));
             connect(demuxThr, SIGNAL(finished()), this, SLOT(demuxThrFinished()));
 
             if (!QMPlay2Core.getSettings().getBool("KeepZoom"))
@@ -188,7 +180,14 @@ void PlayClass::play(const QString &_url)
             demuxThr->start();
 
             if (QMPlay2Core.getSettings().getBool("StoreUrlPos"))
+            {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 2, 0)
                 emit continuePos(QMPlay2Core.getUrlPosSets().getDouble(url.toUtf8().toBase64(QByteArray::Base64UrlEncoding | QByteArray::OmitTrailingEquals)), true);
+#else
+                // Qt4: Use basic base64 encoding
+                emit continuePos(QMPlay2Core.getUrlPosSets().getDouble(url.toUtf8().toBase64()), true);
+#endif
+            }
         }
     }
     else
@@ -293,14 +292,30 @@ void PlayClass::seek(double pos, bool allowAccurate)
 void PlayClass::chStream(const QString &s)
 {
     if (s.startsWith("audio"))
+#if QT_VERSION >= QT_VERSION_CHECK(5, 10, 0)
         chosenAudioStream = QStringView(s).right(s.length() - 5).toInt();
+#else
+        chosenAudioStream = s.right(s.length() - 5).toInt();
+#endif
     else if (s.startsWith("video"))
+#if QT_VERSION >= QT_VERSION_CHECK(5, 10, 0)
         chosenVideoStream = QStringView(s).right(s.length() - 5).toInt();
+#else
+        chosenVideoStream = s.right(s.length() - 5).toInt();
+#endif
     else if (s.startsWith("subtitles"))
+#if QT_VERSION >= QT_VERSION_CHECK(5, 10, 0)
         chosenSubtitlesStream = QStringView(s).right(s.length() - 9).toInt();
+#else
+        chosenSubtitlesStream = s.right(s.length() - 9).toInt();
+#endif
     else if (s.startsWith("fileSubs"))
     {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 10, 0)
         int idx = QStringView(s).right(s.length() - 8).toInt();
+#else
+        int idx = s.right(s.length() - 8).toInt();
+#endif
         if (fileSubsList.count() > idx)
             loadSubsFile(fileSubsList[idx]);
     }
@@ -436,12 +451,17 @@ void PlayClass::messageAndOSD(const QString &txt, bool onStatusBar, double durat
     if (ass && QMPlay2Core.getSettings().getBool("OSD/Enabled"))
     {
         QByteArray txtData;
-        if (QGuiApplication::layoutDirection() == Qt::RightToLeft && txt.size() >= 2)
+        if (QApplication::layoutDirection() == Qt::RightToLeft && txt.size() >= 2)
         {
             // libass puts "%" and "x" character to the right, so swap it
             if (txt.at(txt.size() - 2).isDigit() && (txt.at(txt.size() - 1).isLetter() || txt.at(txt.size() - 1) == QChar('%')))
             {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
                 txtData = (txt.at(txt.size() - 1) + txt.mid(0, txt.size() - 1)).toUtf8();
+#else
+                // Qt4: QStringBuilder doesn't have toUtf8(), wrap in QString
+                txtData = QString(txt.at(txt.size() - 1) + txt.mid(0, txt.size() - 1)).toUtf8();
+#endif
             }
         }
         if (txtData.isNull())
@@ -742,7 +762,7 @@ void PlayClass::applyZoom(bool message)
         if (m_integerScaling && zoom < 1.0)
         {
             const auto zoomRational = av_d2q(zoom, 10);
-            messageAndOSD(text.arg(QStringLiteral("%1/%2").arg(zoomRational.num).arg(zoomRational.den)));
+            messageAndOSD(text.arg(QString("%1/%2").arg(zoomRational.num).arg(zoomRational.den)));
         }
         else if (m_integerScaling)
         {
@@ -1038,7 +1058,7 @@ void PlayClass::aRatio()
         QString msgTxt = tr("Aspect ratio") + ": " + sender->text().remove('&');
         if (custom)
         {
-            msgTxt += QStringLiteral(" (%1)").arg(aRatioName);
+            msgTxt += QString(" (%1)").arg(aRatioName);
         }
         if (hasVideoStream())
         {
@@ -1054,7 +1074,7 @@ void PlayClass::aRatio()
             messageAndOSD(msgTxt);
         }
     };
-    if (aRatioName.startsWith(QStringLiteral("custom:")))
+    if (aRatioName.startsWith(QString("custom:")))
     {
         constexpr double min = 0.5;
         constexpr double max = 3.0;
@@ -1085,7 +1105,7 @@ void PlayClass::aRatio()
                     if (!qFuzzyCompare(value, valueNew))
                     {
                         value = valueNew;
-                        sender->setObjectName(QStringLiteral("custom:%1").arg(value));
+                        sender->setObjectName(QString("custom:%1").arg(value));
                         QMPlay2Core.getSettings().set("CustomAspectRatio", value);
                         setCustomARatio();
                     }
@@ -1555,8 +1575,13 @@ static Decoder *loadStream(
         };
         QVarLengthArray<StreamSearch, 2> modes;
         if (!preferredStreams.empty())
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
             modes.push_back(StreamSearch::Preferred);
         modes.push_back(StreamSearch::All);
+#else
+            modes.append(StreamSearch::Preferred);
+        modes.append(StreamSearch::All);
+#endif
 
         // First search in preferred streams (if any) which belongs to program. If not found - search in all streams.
         for (auto mode : modes)
@@ -1622,7 +1647,7 @@ static Decoder *loadStream(
 
                 if (!lang.isEmpty() && chosenLangStream < 0 && !streams[i]->skip_auto_select)
                 {
-                    for (const QMPlay2Tag &tag : std::as_const(streams[i]->other_info))
+                    for (const QMPlay2Tag &tag : streams[i]->other_info)
                     {
                         if (tag.first.toInt() == QMPLAY2_TAG_LANGUAGE)
                         {
@@ -1701,7 +1726,7 @@ void PlayClass::load(Demuxer *demuxer)
             {
                 const double aspect_ratio = getARatio();
 
-                if (!qIsNaN(streams[videoStream]->rotation))
+                if (!std::isnan(streams[videoStream]->rotation))
                 {
                     const bool is270 = qFuzzyCompare(streams[videoStream]->rotation, 270.0);
                     if (is270 || qFuzzyCompare(streams[videoStream]->rotation, 180.0))
@@ -1928,3 +1953,15 @@ void PlayClass::load(Demuxer *demuxer)
     reload = videoDecErrorLoad = false;
     loadMutex.unlock();
 }
+
+// Qt4: Helper slot implementation
+void PlayClass::handleDemuxerRecording(bool status, bool error, const QString &fileName)
+{
+    if (error)
+        messageAndOSD(tr("Recording error"));
+    else if (status)
+        messageAndOSD(tr("Recording started: %1").arg(fileName));
+    else
+        messageAndOSD(tr("Recording stopped"));
+    emit recording(status && !error);
+}
